using System;
using System.Reflection;
using System.Runtime.InteropServices;
using Mono.Unix;
using Gtk;
using Gdk;
using System.Collections;

namespace Incollector.GUI.Widgets {
	public class GTrayIcon {
		public EventHandler                ExitActivated, AddEntryActivated, MiniSearchActivated;
		public Gtk.DragDataReceivedHandler DragDataReceived;
		
		public  bool IsTrayIcon;
		public Gtk.Window window = null;
		protected StatusIcon icon;
		
		
		public GTrayIcon ()
		{
			IsTrayIcon = true;
			
			this.icon = new StatusIcon ();
			icon.Tooltip = "Incollector";
			icon.Pixbuf = new Gdk.Pixbuf (Assembly.GetEntryAssembly (), "logo-20.png");
			icon.Activate += new EventHandler (OnIconActivated);
			icon.PopupMenu += new PopupMenuHandler (OnIconPopupMenu);
			icon.Visible = true;
		}
		

		protected void on_TrayExit_activate (object o, EventArgs args)
		{
			if (ExitActivated != null)
				ExitActivated (o, args);
		}
		
		
		protected void on_mini_search_activate (object o, EventArgs args)
		{
			if (MiniSearchActivated != null)
				MiniSearchActivated (o, args);
		}
		
		
		protected void on_add_entry_activate (object o, EventArgs args)
		{
			if (AddEntryActivated != null)
				AddEntryActivated (o, args);
		}
		
		
		public void OnIconActivated (object o, EventArgs args)
		{
			if (window != null)
				this.window.Visible = !this.window.Visible;
		}
		
		public void OnIconPopupMenu (object o, EventArgs args)
		{
			Glade.XML m = Glade.XML.FromAssembly ("gui.glade", "TrayMenu", null);
		    m.Autoconnect (this);
			Gtk.Menu TrayMenu = (Gtk.Menu) m.GetWidget ("TrayMenu");
			TrayMenu.ShowAll ();
			TrayMenu.Popup ();
		}
		
		public void Dispose ()
		{
			icon.Visible = false;
			icon.Dispose ();
		}
	}
}
